<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<ng-select
  *ngIf="(type === metadataTypeEnum.Boolean)"
  [disabled]="!editable"
  bindValue="value"
  [ngModel]="asBoolean(value)"
  (ngModelChange)="value = $event"
  [searchable]="false"
  [clearable]="false"
  [multiple]="false"
  (change)="onValueChange()"
  [ngModelOptions]="{standalone: true}">

  <ng-option
    *ngIf="!mandatory"
    [value]="null"
    [innerText]="commonMessages.NO_VALUE">
  </ng-option>

  <ng-option
    *ngFor="let boolValue of [true, false]"
    [value]="boolValue"
    [innerText]="boolValue | booleanName">
  </ng-option>

</ng-select>

<a
  *ngIf="showUrlLink()"
  class="form-control text-wrap text-break"
  [href]="value"
  target="_blank"
  [innerText]="value">
</a>

<input
  *ngIf="type !== metadataTypeEnum.Boolean && !hasSomeRestrictedValues() && !(showUrlLink())"
  class="form-control text-wrap text-break"
  [type]="getMetadataInputType()"
  [step]="getMetadataInputStep()"
  [required]="mandatory"
  [disabled]="!editable"
  [(ngModel)]="value"
  (ngModelChange)="onValueChange()"
  [ngModelOptions]="{standalone: true}">

<ng-select
  *ngIf="(type !== metadataTypeEnum.Boolean && type !== metadataTypeEnum.Date) && hasSomeRestrictedValues() && !(showUrlLink())"
  [disabled]="!editable"
  bindValue="value"
  [(ngModel)]="value"
  [searchable]="false"
  [clearable]="false"
  [multiple]="false"
  (change)="onValueChange()"
  [ngModelOptions]="{standalone: true}">

  <ng-option
    *ngIf="!mandatory"
    [value]="null"
    [innerText]="commonMessages.NO_VALUE">
  </ng-option>

  <ng-option
    *ngFor="let restrictedValue of restrictedValues"
    [value]="restrictedValue"
    [innerText]="restrictedValue | namePipe">
  </ng-option>

</ng-select>

<ng-select
  *ngIf="(type === metadataTypeEnum.Date) && hasSomeRestrictedValues()"
  [disabled]="!editable"
  bindValue="value"
  [(ngModel)]="value"
  [searchable]="false"
  [clearable]="false"
  [multiple]="false"
  (change)="onValueChange()"
  [ngModelOptions]="{standalone: true}">

  <ng-option
    *ngIf="!mandatory"
    [value]="null"
    [innerText]="commonMessages.NO_VALUE">
  </ng-option>

  <ng-option
    *ngFor="let restrictedValue of restrictedValues" [value]="restrictedValue"
    [innerText]="restrictedValue | date: 'shortDate'">
  </ng-option>

</ng-select>
